<?php
class sfw_subscriber{
	
	public function switch_responder( $apikey, $action, $responder ){
		switch($responder){
			/*case 'Mailchimp':
				return $this->Mailchimp( $apikey, $action );
			break;*/
			case 'Sendlane':
				return $this->Sendlane( $apikey, $action );
			break;
		}
	}
	
	public function Sendlane( $apikey, $action ){
		
		if($action == 'getList'){
			$url = $apikey['user_url'];
			$api = $url . '/api/v1/lists';

			$post = array(
				'api'    => $apikey['api_key'],
				'hash'   => $apikey['hash_key']
			);

			$data = "";
			foreach( $post as $key => $value ) $data .= $key . '=' . urlencode($value) . '&';
			$data = rtrim($data, '& ');

			$request = curl_init($api);
			curl_setopt($request, CURLOPT_HEADER, 0);
			curl_setopt($request, CURLOPT_RETURNTRANSFER, 1);
			curl_setopt($request, CURLOPT_POSTFIELDS, $data);
			curl_setopt($request, CURLOPT_FOLLOWLOCATION, true);

			$response = (string)curl_exec($request);
			curl_close($request);


			if( $response == '' ) {
				$result = array('error'=>'Error occur may be somethig wrong.');
			}else {
				$result = json_decode($response);
				if( isset ($result->error) ) {
					$result = array('error'=>'Error occur may be somethig wrong.');
				}else {
					if ( !isset($result[0]->list_id)) {
						$result = array('error'=>'Error occur may be somethig wrong.');
					}else {
						$list = array();
						foreach ($result as $solo_list){
							$list_key = $solo_list->list_id;
							$list_name = $solo_list->list_name;
							$list[$list_key] = $list_name;
						}
						$result['list'] = $list;
					}
				}
			}
		}
		
		if($action === 'subsCribe'){
			$result = array('error'=>'Subscribe unsuccessfully, please contact administrator for more information.');
		
			$url = $apikey['user_url'];
			$api = $url . '/api/v1/list-subscribers-add';

			$email = $apikey['email'];
			$listID = $apikey['listid'];

			if (!empty($apikey['name'])){
				$fname = $apikey['name'];
			}else {
				$fname = '';
			}

			$post = array(
				'api'    => $apikey['api_key'],
				'hash'   => $apikey['hash_key'],
				'email'   => $fname.'<'.$email.'>',
				'list_id' => $listID
			);

			$data = "";
			foreach( $post as $key => $value ) $data .= $key . '=' . urlencode($value) . '&';
			$data = rtrim($data, '& ');

			$request = curl_init($api);
			curl_setopt($request, CURLOPT_HEADER, 0);
			curl_setopt($request, CURLOPT_RETURNTRANSFER, 1);
			curl_setopt($request, CURLOPT_POSTFIELDS, $data);
			curl_setopt($request, CURLOPT_FOLLOWLOCATION, true);

			$response = (string)curl_exec($request);
			curl_close($request);

			if ($response != ''){
				$result = array('success'=>'Subscribe successfully.');
			}
		}
		
		return $result;
	}
		
	public function Mailchimp( $apikey, $action ){
		
		require_once  SFW_PATH.'/subscriber/Mailchimp/MCAPI.class.php';
		
		if($action === 'getList'){
			$key = $apikey['api_key'];
			
			$api = new MCAPI( $key );
			$retval = $api->lists();
			
			if (!$api->errorCode){
				if($retval['data'] != 0){
					foreach ($retval['data'] as $v){
						$list[$v['id']] = $v['name'];
					}
					
					$result['list'] = $list;
					
				}else{
					$result = array('error'=>'There is no list in your account.');
				}
			}else{
				$result = array('error'=>'Error occur may be somethig wrong.');
			}
			
			return $result;
		}
		
		if($action == 'subsCribe'){
			$key = $apikey['api_key'];
			
			$api = new MCAPI( $key );
			
			$listID = $apikey['listid'];
			
			//print_r($apikey);
			if($apikey['name']){
				$args = array('FNAME' => $apikey['name']);
			}else{
				$args = array();
			}
			
			if(!empty($listID)){
				//$api->listSubscribe($listID, $apikey['email'], $args, 'html', false );
				$api->listSubscribe($listID, $apikey['email'], $args );
			}
			
			if ($api->errorCode == ''){
				$result = array('success'=>'Thank you, please check your email.');
			}elseif($api->errorCode == 214){
				$result = array('success'=>'This email already subscribe.');
			}else{
				$result = array('error'=>'Subscribe unsuccessfully, please contact administrator for more information.');
			}
			
			return $result;
			
		}
		
	}
}