<?php
add_action( 'wp_ajax_sfw_save_setting', 'sfw_save_setting' );
add_action( 'wp_ajax_nopriv_sfw_save_setting', 'sfw_save_setting' );
function sfw_save_setting(){
	//print_r($_POST);
	
	$data = get_option('sfw_subscriber_settings');
	
	if(empty($_POST['responder'])){
		echo json_encode(array( 'error' => 'Error occur may be something wrong.'));
		return;
	}
	
	$data[$_POST['responder']] = $_POST['apikey'];
	
	if(isset($_POST['eraser']) && $_POST['eraser'] == 1){
		unset($data[$_POST['responder']]);
		update_option('sfw_subscriber_settings', $data);	
		die();
	}
	
	$objlist = new sfw_subscriber();
	$list = $objlist->switch_responder($_POST['apikey'], 'getList', $_POST['responder']);
	
	if(!isset($list['error'])){
		if($_POST['responder'] != 'Aweber') update_option('sfw_subscriber_settings', $data);	
		echo json_encode(array('success'=>true));
	}else{
		echo json_encode(array( 'error' => 'An error occurred while getting your list.'));
	}
	
	die();
}

add_action( 'wp_ajax_sfw_get_list', 'sfw_get_list' );
add_action( 'wp_ajax_nopriv_sfw_get_list', 'sfw_get_list' );
function sfw_get_list(){	
	$data = get_option('sfw_subscriber_settings');
	
	if(empty($_POST['responder'])){
		echo json_encode(array( 'error' => 'Error occur may be something wrong.'));
		die();
	}
	
	$apikey = $data[$_POST['responder']];
	
	$objlist = new sfw_subscriber();
	$list = $objlist->switch_responder($apikey, 'getList', $_POST['responder']);
	
	if(!isset($list['error'])){
		echo json_encode($list);
	}else{
		echo json_encode(array( 'error' => 'An error occurred while getting your list.'));
	}
	
	die();
}