<?php 
$data = get_option('sfw_subscriber_settings');
$connect = $disconnect = '';


/*if(isset($data['Mailchimp']) && !empty($data['Mailchimp'])){
	$connect .= '<li><a href="#Mailchimp"><img src="' . SFW_URL . '/assets/images/Mailchimp.png" alt=""><p class="sfw_name">'.esc_html__('Mailchimp', 'sendlaneforwoocommerce').'</p> </a></li>';
}else{
	$disconnect .= '<li><a href="#Mailchimp"><img src="' . SFW_URL . '/assets/images/Mailchimp.png" alt=""><p class="sfw_name">'.esc_html__('Mailchimp', 'sendlaneforwoocommerce').'</p> </a></li>';
}*/

if(isset($data['Sendlane']) && !empty($data['Sendlane'])){
	$connect .= '<li><a href="#Sendlane"><img src="' . SFW_URL . '/assets/images/Sendlane.png" alt=""><p class="sfw_name">Sendlane</p> </a></li>';
}else{
	$disconnect .= '<li><a href="#Sendlane"><img src="' . SFW_URL . '/assets/images/Sendlane.png" alt=""><p class="sfw_name">Sendlane</p> </a></li>';
}

?>	
	
	<div class="sfw_wrapper">
	<div class="sfw_tab_container">
		<div class="sfw_heading">
			<h3 class="title"><?php esc_html_e('Applications', 'sendlaneforwoocommerce'); ?></h3>
		</div>
		<ul class="sfw_panel_menu sfw_connect" id="dis-panel-nav">
			<?php echo $disconnect; ?>
		</ul>	
		
		<div class="sfw_heading">
			<h3 class="title"><?php esc_html_e('Connected Applications','sendlaneforwoocommerce'); ?></h3>
		</div>
		<?php if(!empty($connect)){ ?>
		<ul class="sfw_panel_menu sfw_disconnect" id="panel-nav">
			<?php echo $connect; ?>
		</ul>
		<?php }else{ ?>
			<div class="sfw_connect_div">
			<?php esc_html_e( 'There is no connected application.', 'sendlaneforwoocommerce'); ?>
			</div>
		<?php } ?>
		<!--popup for disconnect -->
		<div class="sfw_dis_popup">
			<div class="sfw_dis_content">
				<div class="sfw_heading_section">	
					<span></span>
					<a class="sfw_popup_closer sfw_popup_dis_closer">x</a>
				</div>
				<a class="button button-primary sfw_disconnect_btn" data-responder="" ><?php esc_html_e('Yes', 'sendlaneforwoocommerce'); ?></a> 
				<a class="button button-primary sfw_popup_dis_closer"><?php esc_html_e('No', 'sendlaneforwoocommerce'); ?></a>
			</div>
		</div>
		<!--popup for disconnect -->
		<div id="tab-container" class="sfw_tabs_box sfw_connect_popup">
		<div class="sfw_popup_content">  
			<div class="sfw_heading_section">	
				<span class="sfw_popup_heading"></span>
				<a class="sfw_popup_closer">x</a>
			</div>
						
			<div class="sfw_whole_content" id="Sendlane" style="display:none;">
				<div class="sfw_right_section">
					<div class="sfw_input_section">
						<label><?php esc_html_e('User URL:', 'sendlaneforwoocommerce'); ?></label>
						<input type="text" value="<?php echo isset($data['Sendlane']['user_url']) ? $data['Sendlane']['user_url'] : ''; ?>" placeholder="Enter user url" class="user_url">
						<span></span>
						<p class="sfw_note_desc">Example : youraccount.sendlane.com</p>
					</div>
					<div class="sfw_input_section">
						<label><?php esc_html_e('API Key:', 'sendlaneforwoocommerce'); ?></label>
						<input type="text" value="<?php echo isset($data['Sendlane']['api_key']) ? $data['Sendlane']['api_key'] : ''; ?>" placeholder="Enter API Key" class="api_key">
						<span></span>
					</div>
					<div class="sfw_input_section">
						<label><?php esc_html_e('HASH Key:', 'sendlaneforwoocommerce'); ?></label>
						<input type="text" value="<?php echo isset($data['Sendlane']['hash_key']) ? $data['Sendlane']['hash_key'] : ''; ?>" placeholder="Enter HASH Key" class="hash_key">
						<span></span>
					</div>
					<div class="sfw_input_section">
						<p class="sfw_note_desc">Note : Your API Key and HASH Key are found inside your sendlane account under account setting.</p>
						<?php if(empty($data['Sendlane'])){ ?>
							<button class="sfw_btn_submit button button-primary" data-responder="Sendlane"><?php esc_html_e('Connect', 'sendlaneforwoocommerce'); ?></button>
							<button class="sfw_popup_cancel button button-primary"><?php esc_html_e('Cancel', 'sendlaneforwoocommerce'); ?></button>
						<?php } ?>
						<div class="sfw_loading"></div>
						<span></span>
					</div>
				</div>
			</div>
			
			<div class="sfw_whole_content" id="Mailchimp" style="display:none;">
				<div class="sfw_right_section">
					<div class="sfw_input_section">
						<label><?php esc_html_e('API Key:', 'sendlaneforwoocommerce'); ?></label>
						<input type="text" value="<?php echo isset($data['Mailchimp']['api_key']) ? $data['Mailchimp']['api_key'] : ''; ?>" placeholder="Enter API Key" class="api_key">
						<span></span>
					</div>					
					<div class="sfw_input_section">
						<?php if(empty($data['Mailchimp'])){ ?>
							<button class="sfw_btn_submit button button-primary" data-responder="Mailchimp"><?php esc_html_e('Connect', 'sendlaneforwoocommerce'); ?></button>
							<button class="sfw_popup_cancel button button-primary"><?php esc_html_e('Cancel', 'sendlaneforwoocommerce'); ?></button>
						<?php } ?>
						<div class="sfw_loading"></div>
						<span></span>
					</div>
				</div>
			</div>
			
		</div>
			
		</div>
	</div>
	
</div>